/*
Copyright Renaud GICQUEL 2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.corps.*;
import java.util.*; 
import com.sun.java.swing.*;

/**
 * classe de condensation sur batterie froide
 * 
 * @author Renaud GICQUEL
 */
public class DehumidifyingCoil extends ExtDivider implements Inversable
{
    
	com.sun.java.swing.JLabel JLabel1 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField condenserLoad_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel2 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField epsi_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel3 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField ts_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel4 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Compr_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel5 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Tout_value = new com.sun.java.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P, Pinlet, Tinlet, Hinlet, wInlet, wetGasFlow, w2, qprime2;
    String wetGasProcess,H2OProcess,dryGasProcess,dryGasSubstanceName,H2OSubstanceName;
    String wetGasPoint,H2OPoint,dryGasPoint;
    rg.corps.Corps dryGasSubstance;
    rg.corps.Corps H2OSubstance;
    
    double[]inletWetGasFractmol;
    String[]inletWetGasComp;
    Vector inputWetGasComp, dryGasComp;
    double fractH2O,Htot,wetGasM,inlet_w,Qprime_inlet;
    
    String outletMethanolAbsorName="";
    
    double epsi,tau;
    
    public DehumidifyingCoil (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("efficiency");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(epsi_value);
		epsi_value.setBounds(164,0,100,20);
		epsi_value.setText("0.5");
		JLabel2.setText("condenser load");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,164,20);
		JPanel1.add(condenserLoad_value);
		condenserLoad_value.setBounds(164,24,100,20);
		condenserLoad_value.setText("0.5");
		JLabel3.setText("surface temp. (C)");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
		JPanel1.add(ts_value);
		ts_value.setBounds(164,48,100,20);
		ts_value.setText("0");
		JLabel4.setText("compression power");
	//	JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
	//	JPanel1.add(Compr_value);
		Compr_value.setBounds(164,72,100,20);
		Compr_value.setText("0");
		JLabel5.setText("H2O temperature (C)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,164,20);
		JPanel1.add(Tout_value);
		Tout_value.setBounds(164,96,100,20);
		Tout_value.setText("0");
		type=getType();
		thermoCouplerTypes=new String[1];
 		thermoCouplerTypes[0]="cooler";
    }
    public void init(){
	    getDividerStructure();
        checkConsistency();
        calculateProcess();
    }
    
    public String getType(){
        return "dehumidifying coil";
    }
	public String getClassDescription(){
	    return "dehumidifying coil\none thermocoupler\n\nauthor : R. Gicquel  april 2006\n\nRef : CoolingCoils.doc";
	}
    
    private double getEpsilon(){
        
        return Util.lit_d(epsi_value.getText());//lecture  l'cran de la valeur de espilon
        
    }
	public void calculateProcess(){
	
	    getDividerStructure();
        checkConsistency();
	    
	    if(isBuilt){//si le noeud externe est bien configur
	    
            epsi=getEpsilon();//mthode de calcul de epsilon

	        dryGasComp=inputWetGasComp;
	        
	        //Initialisations relatives  l'tat de l'air entrant
	        getPointProperties(wetGasPoint);
	        wInlet=Wpoint;
	        Tinlet=Tpoint;
	        double test=(inlet_w-wInlet)*(inlet_w-wInlet)/wInlet/wInlet;
	        System.out.println("inlet_w : "+inlet_w+" wInlet : "+wInlet+" test : "+test);
	        if(test>0.0001){
	            String msg = "Watch out: the composition of the inlet humid air is not consistent with its humidity.\nYou should modify its composition in the point screen.";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
            double flow_as=wetGasFlow/(1+Wpoint);//dbit massique de gaz sec
            
            //calcul des proprits humides en entre du composant
	        updatepoint(wetGasPoint, false, 0,  //T
                false, 0, false, 0,//P,x
//                true, "setW and calculate all", wInlet);
                true, "setW and calculate q'", wInlet);
	        getPointProperties(wetGasPoint);//direct parsing of point property vector
	        double qprimeInlet=QPrimepoint;
	        System.out.println(" winlet : "+Wpoint+" epsi : "+Epsipoint+" q' : "+QPrimepoint+" t' : "+Tprimepoint);
            
            //rcupration du nom de la transfo couple au composant par le thermocoupleur
	        String thcoupl=(String)de.de.getThermoCouplerData("cooler").elementAt(0);
                System.out.println(" thermocoupler : "+thcoupl);
            if((thcoupl!=null)&&(!thcoupl.equals("null"))){
	            String[] args=new String[2];
	            args[0]="heatEx";
	            args[1]=thcoupl;
                Vector vProp=proj.getProperties(args);
                String trsf=(String)vProp.elementAt(0);
                System.out.println("hot : "+trsf+" cold : "+(String)vProp.elementAt(1));
	            args[0]="process";
	            args[1]=trsf;
                vProp=proj.getProperties(args);
                String amont=(String)vProp.elementAt(1);
	            getPointProperties(amont);
	            //Tpoint contient la valeur de la temprature d'entre du fluide de refroidissement
	            ts_value.setText(Util.aff_d(Tpoint-273.15,3));
            }
            double ts=Util.lit_d(ts_value.getText());
            
            
            //calcul des conditions de saturation pour l'air sortant
            updatepoint(dryGasPoint, true, ts+273.15,  //T
                false, 0, false, 0,//P,x
                false, "", 0);
            
	        updatepoint(dryGasPoint, false, 0,  //T
                    false, 0, false, 0,//P,x
                    true, "setEpsi and calculate", 1);
	        getPointProperties(dryGasPoint);//proprits  la saturation
	        
	        double wsat_ts=Wpoint;
	        double qprime_ts=QPrimepoint;
	        System.out.println(" wsat : "+Wpoint+" epsi : "+Epsipoint+" q' : "+QPrimepoint+" t' : "+Tprimepoint);
            
            
            //calcul de l'tat final recherch
            w2=epsi*wsat_ts+(1-epsi)*wInlet;
            qprime2=epsi*qprime_ts+(1-epsi)*qprimeInlet;
            
            //prparation du test sur la zone sature
            double tapp=epsi*ts+(1-epsi)*(Tinlet-273.15);
            updatepoint(dryGasPoint, true, tapp+273.15,  //T
                false, 0, false, 0,//P,x
                false, "", 0);
            
	        updatepoint(dryGasPoint, false, 0,  //T
                    false, 0, false, 0,//P,x
                    true, "setEpsi and calculate", 1);
	        getPointProperties(dryGasPoint);//proprits  la saturation	        
	        double wsat_tapp=Wpoint;
	        
	        
            double T=0;
            if(w2>wsat_tapp){//Si le point est dans la zone sature 
                T=Util.dicho_T(this, 0, Pinlet, "qprime2sat", ts+273.15, Tinlet, 0.01);
            }
            else{//sinon
                T=Util.dicho_T(this, 0, Pinlet, "qprime2", ts+273.15, Tinlet, 0.01);
	        }
            
            //modification de la composition du gaz
	        updatepoint(dryGasPoint, false, 0,  //T
                    false, 0, false, 0,//P,x
                    true, "modHum", 0);
            
            //charge du condenseur  Qprime_inlet
//            double DeltaQprime=flow_as*(qprime2-qprimeInlet);//enthalpie totale acquise par l'air
            double DeltaQprime=flow_as*qprime2-Qprime_inlet;//enthalpie totale acquise par l'air
            double condLoad=DeltaQprime;
            
            //eau mise en jeu
  //          double H2Oflow=(wInlet-Wpoint)*flow_as;
            double H2Oflow=(inlet_w-Wpoint)*flow_as;
            
	        System.out.println(" w2 : "+w2+" epsi : "+Epsipoint+" q'2 : "+qprime2+" t' : "+Tprimepoint);
	        System.out.println(" T : "+T+" waterFlow : "+H2Oflow+" flow_as : "+flow_as+" t' : "+Tprimepoint);
	        
            //affichages  l'cran
            condenserLoad_value.setText(Util.aff_d(condLoad,2));
            Tout_value.setText(Util.aff_d(T-273.15,2));
            epsi_value.setText(Util.aff_d(epsi,4));

            //mise  jour des thermocoupleurs, comme pinchFluid, DTmin=10
	        updateThermoCoupler("cooler", Tinlet, T, condLoad, wetGasFlow,true,10);
	   
	        //mise  jour du noeud en utilisant les mthodes gnriques
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(H2OProcess, H2OPoint, 0, H2Oflow, T, Pinlet, 0);
	        setupVector(dryGasProcess, dryGasPoint, 1, wetGasFlow-H2Oflow, T, Pinlet, 0);
	        setupVector(wetGasProcess, wetGasPoint, 2, wetGasFlow, Tinlet, Pinlet, 1);
            updateDivider(vTransfo,vPoints,Tinlet,Hinlet*wetGasFlow);

	        de.updateProcess(setEnergyTypes(wetGasProcess,0,0,0));
        }

	}
	
	
    public double f_dicho(double T, double P, String fonc){
        
        if (fonc.equals("qprime2")){//point final hors zone sature
            double diff;
	        updatepoint(dryGasPoint, true, T,  //T
                false, 0, false, 0,//P,x
                false, "", 0);
	        updatepoint(dryGasPoint, false, 0,  //T
                false, 0, false, 0,//P,x
                true, "setW and calculate q'", w2);
            
	        getPointProperties(dryGasPoint);//proprits humides
            diff=qprime2-QPrimepoint;
            return diff;
        }
        if (fonc.equals("qprime2sat")){//point final satur
            double diff;
	        updatepoint(dryGasPoint, true, T,  //T
                false, 0, false, 0,//P,x
                false, "", 0);
	        updatepoint(dryGasPoint, false, 0,  //T
                    false, 0, false, 0,//P,x
                    true, "setEpsi and calculate", 1);
            
	        getPointProperties(dryGasPoint);//proprits h"
            diff=qprime2-QPrimepoint;
            return diff;
        }
        return 0;
    }
	
	
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        H2OProcess="";
        dryGasProcess="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                String nom=nomCorps;
                if(typeSubst==1){//le corps de sortie est de l'eau
	                H2OProcess=nomBranche[j];
	                H2OPoint=amont;
	            }
	            else if(typeSubst==4){//le corps de sortie est un gaz compos
	                dryGasProcess=nomBranche[j];
	                dryGasPoint=amont;
                    args=new String[2];
                    args[0]="process";//type of the element (see method getProperties(String[] args))
                    args[1]=dryGasProcess;//name of the process (see method getProperties(String[] args))
                    Vector vProp=proj.getProperties(args);
                    amont=(String)vProp.elementAt(1);//gets the upstream point name
                    getPointProperties(amont);//direct parsing of point property vector
	                dryGasSubstance=lecorps;
	                dryGasSubstanceName=nomCorps;
	            }
	            else{//le corps de sortie n'est ni de l'eau ni un gaz compos
	                String msg = "Error: the outlet substance is not of the right type";
	                JOptionPane.showMessageDialog(de, msg);  
	            }
	        }
	        if((H2OProcess.equals(""))||(dryGasProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        wetGasProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=wetGasProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    wetGasFlow=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
        Vector vComp=lecorps.getGasComposition();
	    wetGasPoint=aval;
	    Tinlet=Tpoint;
	    Hinlet=Hpoint;
	    Pinlet=Ppoint;
        
	    lecorps.CalcPropCorps(273.15,Ppoint, 1); //calcul de l'tat de rfrence
        getSubstProperties(nomCorps);
        double h0subst=Hsubst;

	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputWetGasComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractH2O=Util.molarComp(inputWetGasComp,"H2O");//fraction molaire de H2O
        
        //on calcule w inlet par la formule de dfinition, pour viter, compte tenu de la
        //temprature leve du gaz, d'avoir  estimer les conditions de saturation
        //cf. p. 71-72 tome 1
        inlet_w=fractH2O*18.01528/M_secpoint/(1-fractH2O);//(M_H2O)(x_H2O)/(M_gs)/(x_gs)
        double L0_eau=2501.593;  
        
        //Enthalpie totale d'entre
        Qprime_inlet=((Hinlet-h0subst)+inlet_w*L0_eau/(1+inlet_w))*wetGasFlow;
        
        
        wetGasM=Msubst;//masse molaire du gaz  traiter
        Htot=Hsubst*wetGasFlow;
//            System.out.println("Htot : "+Htot);
        //chargement du tableau des fractions molaires du gaz  traiter
        Integer i=(Integer)inputWetGasComp.elementAt(0);
	    int nComp=i.intValue(); 
        inletWetGasComp= new String[nComp];
        Double[]fracMol= new Double[nComp];
        inletWetGasFractmol= new double[nComp];
	    inletWetGasComp=(String[])inputWetGasComp.elementAt(1);
	    fracMol=(Double[])inputWetGasComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletWetGasFractmol[j]= fracMol[j].doubleValue();
        }
        
	    
	    

        //Check the substance at inlet
	    if(!((typeSubst==4)&&(Util.contains(vComp,"H2O")))){
	        String msg = "Error on main process substance,which is not a gas containing H2O";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
	    }
        
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "condenserLoad_value");
        double condenserLoad=0;
        if(valeur!=null)condenserLoad=Util.lit_d(valeur);
	    condenserLoad_value.setText(Util.aff_d(condenserLoad,3));
		double Tout=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tout,2));
		double Q=Util.lit_d(Util.extr_value(ligne_data, "ts_value"));
	    ts_value.setText(Util.aff_d(Q,2));
		double current=Util.lit_d(Util.extr_value(ligne_data, "Compr_value"));
	    Compr_value.setText(Util.aff_d(current,2));
	    valeur=Util.extr_value(ligne_data, "epsi_value");
        if(valeur!=null)epsi=Util.lit_d(valeur);
	    epsi_value.setText(Util.aff_d(epsi,4));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"epsi_value="+epsi_value.getText()+tab
	    +"condenserLoad_value="+condenserLoad_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"ts_value="+ts_value.getText()+tab
	    +"Compr_value="+Compr_value.getText()+tab
	    ;
        return h;
    }
}